/*
 * Copyright (c) 2008-2010 Lu, Chao-Ming (Tetralet).  All rights reserved.
 * 
 * This file is part of LilyTerm.
 *
 * LilyTerm is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * LilyTerm is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with LilyTerm.  If not, see <http://www.gnu.org/licenses/>.
 */

#define _GNU_SOURCE

#include <gtk/gtk.h>
#include <vte/vte.h>
// for L10n
#include <locale.h>
#include <glib/gi18n.h>
// for aoti() aotf() canonicalize_file_name()
#include <stdlib.h>
// for access()
#include <unistd.h>
// for strcmp()
#include <string.h>

#include "lilyterm.h"

void init_command();
void init_user_command(struct Window *win_data);
void init_window_parameters(struct Window *win_data);
void init_user_keys(struct Window *win_data);
void init_function_keys_name_and_group();
void init_function_keys();
void init_page_color_data();
void init_page_color_data_comment();
void init_mod_keys();
void init_colors();
void init_user_color_data(struct Window *win_data);
gchar *load_profile_from_dir(const gchar *dir, const gchar* profile);
gdouble check_double_value(GKeyFile *keyfile, const gchar *group_name, const gchar *key, const gdouble default_value);
gint check_integer_value(GKeyFile *keyfile, const gchar *group_name, const gchar *key,
			 const gint default_value, gboolean enable_empty, gboolean enable_zero,
			 gboolean check_min, gint min, gboolean check_max, gint max);
void check_color_value (const gchar *key_name, const gchar *color_name, GdkColor *color);
gboolean accelerator_parse(const gchar *key_name, const gchar *key_value, guint *key, guint *mods);
void clean_accelerator_parse_data(gchar **values, gchar **functions);
void create_save_fauilt_dialog(struct Window *win_data, gchar *message);
void free_user_settings_data(GError *error, gchar *profile, GString* contents, GKeyFile *keyfile, gboolean use_custom_profile);
